import contextlib
import functools
import inspect
from collections.abc import Callable
from typing import Any, Generic, TypeVar, cast

import pydantic.v1 as pydv1


class PydanticModel(pydv1.BaseModel): ...


T = TypeVar("T")


class Command(Generic[T]):
    """Command to be invoked through CLI."""

    def __init__(self, function: Callable[..., T], /, *args: Callable[[], Any]) -> None:
        """Constructor for `Command`.

        Args:
          function: The function to create a command for.
          args: Function(s) to initialize args that are then passed to `function`,
            as a form of dependency injection. Can be used e.g. for generating a spark
            context based on config only available when the command is executed. Note
            that the order of args needs to the same as expected by `function`, and the
            users of the command won't be prompted for injected args. All unspecified
            arguments of function will instead be present in the pydantic args model
            generated by the command.
        """
        self._function = function
        self._args = args

    def __call__(self, json_args: str) -> T:
        return self.callback(json_args)

    @property
    def name(self) -> str:
        _package, _, qualifier = self._function.__module__.partition(".")
        qualified_name = f"{qualifier}.{self._function.__qualname__}"
        formatted_name = qualified_name.translate(
            # maketrans type issue: https://github.com/python/mypy/issues/4374
            str.maketrans(dict.fromkeys(("_", "<", ">"), ""))  # type:ignore[arg-type]
        )
        return formatted_name

    @functools.cached_property
    def args(self) -> type[PydanticModel]:
        """Pydantic model for parsing and validating arguments to
        the underlying function.

        Model field types are inferred from type annotations on the function,
        arguments without a type decorator are considered as `Any`.
        """
        function = self._function

        # If there are args that we don't want users to supply through
        # CLI, we need to remove those from the signature so that pydantic
        # does not add them to the args model. We do this by creating a new
        # function with the desired signature and annotations.
        if self._args:
            # To dynamically construct a new signature, we partially apply
            # placeholder args to the function. We don't apply the actual args
            # from self._args because we want to delay their initialization until
            # the command actually gets invoked.
            placeholder_args = (None,) * len(self._args)
            partial_function = functools.partial(self._function, *placeholder_args)
            partial_signature = inspect.signature(partial_function)

            # Partial functions don't retain annotations, so we filter original
            # annotations to remove all parameters with placeholder arguments.
            original_annotations = inspect.get_annotations(function).items()
            partial_annotations = {
                param: hint
                for param, hint in original_annotations
                if param in partial_signature.parameters
            }

            def annotated_function(*args: Any, **kwargs: Any) -> T:
                return function(*args, **kwargs)

            # Switch out the signature and annotations of a newly created
            # dummy function with our dynamically constructed ones.
            setattr(annotated_function, "__name__", function.__name__)
            setattr(annotated_function, "__signature__", partial_signature)
            setattr(annotated_function, "__annotations__", partial_annotations)
            function = annotated_function

        model = pydv1.decorator.ValidatedFunction(function=function, config=None).model
        return cast(type[PydanticModel], model)

    @functools.cached_property
    def callback(self) -> Callable[[str], T]:
        """Callback that takes a json encoded string, parses it using
        Pydantic and passes it to the function.

        Any `args` passed to the constructor are called. For args that are
        generator functions, the generator will be resumed after the command
        function returns, so any clean up code etc. should go there.
        """

        def function(json_args: str) -> Any:
            with contextlib.ExitStack() as stack:
                # Create context managers for args that are generator functions
                # and then stack their exit callbacks i.e. code after `yield`, so
                # that they're all run once this `with` block is exited.
                args = [
                    stack.enter_context(contextlib.contextmanager(arg)())
                    if inspect.isgeneratorfunction(arg)
                    else arg()
                    for arg in self._args
                ]
                kwargs = self.args.parse_raw(json_args).dict(skip_defaults=True)
                return self._function(*args, **kwargs)

        return function
